
#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <iostream>
#include <tchar.h>

int _tmain()
{
    const TCHAR* portname = _T("\\\\.\\COM9");

    HANDLE hComPort = ::CreateFile(portname, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hComPort == INVALID_HANDLE_VALUE)
    {
        wprintf(_T("Failed to open COM port.\n"));
        return FALSE;
    }
    wprintf(_T("COM port opened.\n"));

    // Set port settings
    DCB dcb;
    //::GetCommState(m_portHandle, &dcb);
    ::memset(&dcb, 0, sizeof(dcb));
    dcb.DCBlength = sizeof(dcb);
    dcb.BaudRate = 0;  //TODO: 9600
    dcb.ByteSize = 8;
    dcb.fBinary = 1;
    dcb.fParity = FALSE;
    dcb.fOutxCtsFlow = dcb.fOutxDsrFlow = FALSE;
    dcb.fDtrControl = DTR_CONTROL_DISABLE;
    dcb.fDsrSensitivity = FALSE;
    dcb.fTXContinueOnXoff = FALSE;
    dcb.fOutX = dcb.fInX = FALSE;
    dcb.fErrorChar = FALSE;
    dcb.fNull = FALSE;
    dcb.fRtsControl = RTS_CONTROL_DISABLE;
    dcb.fAbortOnError = FALSE;
    dcb.Parity = NOPARITY;
    dcb.StopBits = ONESTOPBIT;
    if (!::SetCommState(hComPort, &dcb))
    {
        ::CloseHandle(hComPort);
        hComPort = INVALID_HANDLE_VALUE;
        wprintf(_T("Failed to configure the COM port.\n"));
        return FALSE;
    }

    // Set timeouts: ReadIntervalTimeout value of MAXDWORD, combined with zero values for both the ReadTotalTimeoutConstant
    // and ReadTotalTimeoutMultiplier members, specifies that the read operation is to return immediately with the bytes
    // that have already been received, even if no bytes have been received.
    COMMTIMEOUTS timeouts;
    timeouts.ReadIntervalTimeout = MAXDWORD;
    timeouts.ReadTotalTimeoutConstant = 0;
    timeouts.ReadTotalTimeoutMultiplier = 0;
    if (!::SetCommTimeouts(hComPort, &timeouts))
    {
        ::CloseHandle(hComPort);
        hComPort = INVALID_HANDLE_VALUE;
        wprintf(_T("Failed to set the COM port timeouts.\n"));
        return FALSE;
    }

    // Clear port input buffer
    ::PurgeComm(hComPort, PURGE_RXABORT|PURGE_RXCLEAR);

    wprintf(_T("COM port configured.\n"));

    wprintf(_T("Waiting for byte 0100...\n"));
    while (true)
    {
        BYTE b;
        DWORD dwBytesRead = 0;
        if (!::ReadFile(hComPort, &b, 1, &dwBytesRead, NULL))
            continue;
        //wprintf(_T("0x%02x\n"), (int)b);
        if (dwBytesRead <= 0) continue;
        if (b == 0100) break;
    }

    wprintf(_T("Reading input file...\n"));
    FILE* fpfile = ::_wfopen(_T("noboot.bin"), _T("r+b"));
    BYTE buffer[512];
    size_t lBytesRead = ::fread(buffer, 1, 512, fpfile);
    ::fclose(fpfile);

    wprintf(_T("Sending bytes...\n"));
    for (int i = 0; i < 512; i++)
    {
        DWORD dwBytesWritten;
        ::WriteFile(hComPort, buffer + i, 1, &dwBytesWritten, NULL);
    }

    ::CloseHandle(hComPort);
    wprintf(_T("COM port closed.\n"));
}
